/* graph-stacked-renderer.c generated by valac 0.48.15, the Vala compiler
 * generated from graph-stacked-renderer.vala, do not modify */

/* graph-stacked-renderer.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <dazzle.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>

#define USAGE_TYPE_GRAPH_STACKED_RENDERER (usage_graph_stacked_renderer_get_type ())
#define USAGE_GRAPH_STACKED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer))
#define USAGE_GRAPH_STACKED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRendererClass))
#define USAGE_IS_GRAPH_STACKED_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER))
#define USAGE_IS_GRAPH_STACKED_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_GRAPH_STACKED_RENDERER))
#define USAGE_GRAPH_STACKED_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRendererClass))

typedef struct _UsageGraphStackedRenderer UsageGraphStackedRenderer;
typedef struct _UsageGraphStackedRendererClass UsageGraphStackedRendererClass;
typedef struct _UsageGraphStackedRendererPrivate UsageGraphStackedRendererPrivate;
enum  {
	USAGE_GRAPH_STACKED_RENDERER_0_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY,
	USAGE_GRAPH_STACKED_RENDERER_NUM_PROPERTIES
};
static GParamSpec* usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_NUM_PROPERTIES];

struct _UsageGraphStackedRenderer {
	GObject parent_instance;
	UsageGraphStackedRendererPrivate * priv;
};

struct _UsageGraphStackedRendererClass {
	GObjectClass parent_class;
};

struct _UsageGraphStackedRendererPrivate {
	guint _column;
	gdouble _line_width;
	GdkRGBA _stroke_color_rgba;
	GdkRGBA _stacked_color_rgba;
};

static gint UsageGraphStackedRenderer_private_offset;
static gpointer usage_graph_stacked_renderer_parent_class = NULL;
static DzlGraphRendererInterface * usage_graph_stacked_renderer_dzl_graph_view_renderer_parent_iface = NULL;

GType usage_graph_stacked_renderer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageGraphStackedRenderer, g_object_unref)
static void usage_graph_stacked_renderer_real_render (DzlGraphRenderer* base,
                                               DzlGraphModel* model,
                                               gint64 x_begin,
                                               gint64 x_end,
                                               gdouble y_begin,
                                               gdouble y_end,
                                               cairo_t* cr,
                                               cairo_rectangle_int_t* area);
static gdouble usage_graph_stacked_renderer_calc_x (DzlGraphModelIter* iter,
                                             gint64 begin,
                                             gint64 end,
                                             guint width);
static gdouble usage_graph_stacked_renderer_calc_y (DzlGraphModelIter* iter,
                                             gdouble range_begin,
                                             gdouble range_end,
                                             guint height,
                                             guint column);
guint usage_graph_stacked_renderer_get_column (UsageGraphStackedRenderer* self);
gdouble usage_graph_stacked_renderer_get_line_width (UsageGraphStackedRenderer* self);
void usage_graph_stacked_renderer_get_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                          GdkRGBA * result);
void usage_graph_stacked_renderer_get_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                         GdkRGBA * result);
UsageGraphStackedRenderer* usage_graph_stacked_renderer_new (void);
UsageGraphStackedRenderer* usage_graph_stacked_renderer_construct (GType object_type);
void usage_graph_stacked_renderer_set_column (UsageGraphStackedRenderer* self,
                                              guint value);
void usage_graph_stacked_renderer_set_line_width (UsageGraphStackedRenderer* self,
                                                  gdouble value);
void usage_graph_stacked_renderer_set_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                         GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
void usage_graph_stacked_renderer_set_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                          GdkRGBA * value);
static void usage_graph_stacked_renderer_finalize (GObject * obj);
static GType usage_graph_stacked_renderer_get_type_once (void);
static void _vala_usage_graph_stacked_renderer_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_usage_graph_stacked_renderer_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
usage_graph_stacked_renderer_get_instance_private (UsageGraphStackedRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, UsageGraphStackedRenderer_private_offset);
}

static void
usage_graph_stacked_renderer_real_render (DzlGraphRenderer* base,
                                          DzlGraphModel* model,
                                          gint64 x_begin,
                                          gint64 x_end,
                                          gdouble y_begin,
                                          gdouble y_end,
                                          cairo_t* cr,
                                          cairo_rectangle_int_t* area)
{
	UsageGraphStackedRenderer * self;
	DzlGraphModelIter iter = {0};
	DzlGraphModelIter _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble _tmp15_;
	GdkRGBA _tmp16_;
	GdkRGBA _tmp17_;
	GdkRGBA _tmp18_;
	GdkRGBA _tmp19_;
	cairo_rectangle_int_t _tmp20_;
	DzlGraphModelIter _tmp21_ = {0};
	gboolean _tmp22_;
	GdkRGBA _tmp35_;
	GdkRGBA _tmp36_;
	GdkRGBA _tmp37_;
	GdkRGBA _tmp38_;
	self = (UsageGraphStackedRenderer*) base;
	g_return_if_fail (model != NULL);
	g_return_if_fail (cr != NULL);
	g_return_if_fail (area != NULL);
	cairo_save (cr);
	_tmp1_ = dzl_graph_view_model_get_iter_first (model, &_tmp0_);
	iter = _tmp0_;
	if (_tmp1_) {
		gdouble chunk = 0.0;
		cairo_rectangle_int_t _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		gdouble last_x = 0.0;
		DzlGraphModelIter _tmp5_;
		cairo_rectangle_int_t _tmp6_;
		gdouble last_y = 0.0;
		cairo_rectangle_int_t _tmp7_;
		cairo_rectangle_int_t _tmp8_;
		_tmp2_ = *area;
		_tmp3_ = dzl_graph_view_model_get_max_samples (model);
		_tmp4_ = _tmp3_;
		chunk = (_tmp2_.width / ((gdouble) (_tmp4_ - 1))) / 2.0;
		_tmp5_ = iter;
		_tmp6_ = *area;
		last_x = usage_graph_stacked_renderer_calc_x (&_tmp5_, x_begin, x_end, (guint) _tmp6_.width);
		_tmp7_ = *area;
		last_y = (gdouble) _tmp7_.height;
		_tmp8_ = *area;
		cairo_move_to (cr, last_x, (gdouble) _tmp8_.height);
		while (TRUE) {
			gboolean _tmp9_;
			gdouble x = 0.0;
			DzlGraphModelIter _tmp10_;
			cairo_rectangle_int_t _tmp11_;
			gdouble y = 0.0;
			DzlGraphModelIter _tmp12_;
			cairo_rectangle_int_t _tmp13_;
			guint _tmp14_;
			_tmp9_ = dzl_graph_view_model_iter_next (&iter);
			if (!_tmp9_) {
				break;
			}
			_tmp10_ = iter;
			_tmp11_ = *area;
			x = usage_graph_stacked_renderer_calc_x (&_tmp10_, x_begin, x_end, (guint) _tmp11_.width);
			_tmp12_ = iter;
			_tmp13_ = *area;
			_tmp14_ = self->priv->_column;
			y = usage_graph_stacked_renderer_calc_y (&_tmp12_, y_begin, y_end, (guint) _tmp13_.height, _tmp14_);
			cairo_curve_to (cr, last_x + chunk, last_y, last_x + chunk, y, x, y);
			last_x = x;
			last_y = y;
		}
	}
	_tmp15_ = self->priv->_line_width;
	cairo_set_line_width (cr, _tmp15_);
	_tmp16_ = self->priv->_stacked_color_rgba;
	_tmp17_ = self->priv->_stacked_color_rgba;
	_tmp18_ = self->priv->_stacked_color_rgba;
	_tmp19_ = self->priv->_stacked_color_rgba;
	cairo_set_source_rgba (cr, _tmp16_.red, _tmp17_.green, _tmp18_.blue, _tmp19_.alpha);
	_tmp20_ = *area;
	cairo_rel_line_to (cr, (gdouble) 0, (gdouble) _tmp20_.height);
	cairo_stroke_preserve (cr);
	cairo_close_path (cr);
	cairo_fill (cr);
	_tmp22_ = dzl_graph_view_model_get_iter_first (model, &_tmp21_);
	iter = _tmp21_;
	if (_tmp22_) {
		gdouble chunk = 0.0;
		cairo_rectangle_int_t _tmp23_;
		guint _tmp24_;
		guint _tmp25_;
		gdouble last_x = 0.0;
		DzlGraphModelIter _tmp26_;
		cairo_rectangle_int_t _tmp27_;
		gdouble last_y = 0.0;
		cairo_rectangle_int_t _tmp28_;
		_tmp23_ = *area;
		_tmp24_ = dzl_graph_view_model_get_max_samples (model);
		_tmp25_ = _tmp24_;
		chunk = (_tmp23_.width / ((gdouble) (_tmp25_ - 1))) / 2.0;
		_tmp26_ = iter;
		_tmp27_ = *area;
		last_x = usage_graph_stacked_renderer_calc_x (&_tmp26_, x_begin, x_end, (guint) _tmp27_.width);
		_tmp28_ = *area;
		last_y = (gdouble) _tmp28_.height;
		cairo_move_to (cr, last_x, last_y);
		while (TRUE) {
			gboolean _tmp29_;
			gdouble x = 0.0;
			DzlGraphModelIter _tmp30_;
			cairo_rectangle_int_t _tmp31_;
			gdouble y = 0.0;
			DzlGraphModelIter _tmp32_;
			cairo_rectangle_int_t _tmp33_;
			guint _tmp34_;
			_tmp29_ = dzl_graph_view_model_iter_next (&iter);
			if (!_tmp29_) {
				break;
			}
			_tmp30_ = iter;
			_tmp31_ = *area;
			x = usage_graph_stacked_renderer_calc_x (&_tmp30_, x_begin, x_end, (guint) _tmp31_.width);
			_tmp32_ = iter;
			_tmp33_ = *area;
			_tmp34_ = self->priv->_column;
			y = usage_graph_stacked_renderer_calc_y (&_tmp32_, y_begin, y_end, (guint) _tmp33_.height, _tmp34_);
			cairo_curve_to (cr, last_x + chunk, last_y, last_x + chunk, y, x, y);
			last_x = x;
			last_y = y;
		}
	}
	_tmp35_ = self->priv->_stroke_color_rgba;
	_tmp36_ = self->priv->_stroke_color_rgba;
	_tmp37_ = self->priv->_stroke_color_rgba;
	_tmp38_ = self->priv->_stacked_color_rgba;
	cairo_set_source_rgba (cr, _tmp35_.red, _tmp36_.green, _tmp37_.blue, _tmp38_.alpha);
	cairo_stroke (cr);
	cairo_restore (cr);
}

static gdouble
usage_graph_stacked_renderer_calc_x (DzlGraphModelIter* iter,
                                     gint64 begin,
                                     gint64 end,
                                     guint width)
{
	gint64 timestamp = 0LL;
	DzlGraphModelIter _tmp0_;
	gdouble result = 0.0;
	g_return_val_if_fail (iter != NULL, 0.0);
	_tmp0_ = *iter;
	timestamp = dzl_graph_view_model_iter_get_timestamp (&_tmp0_);
	result = ((timestamp - begin) / ((gdouble) (end - begin))) * width;
	return result;
}

static gdouble
usage_graph_stacked_renderer_calc_y (DzlGraphModelIter* iter,
                                     gdouble range_begin,
                                     gdouble range_end,
                                     guint height,
                                     guint column)
{
	gdouble y = 0.0;
	GValue val = {0};
	DzlGraphModelIter _tmp0_;
	GValue _tmp1_ = {0};
	gdouble result = 0.0;
	g_return_val_if_fail (iter != NULL, 0.0);
	_tmp0_ = *iter;
	dzl_graph_view_model_iter_get_value (&_tmp0_, column, &_tmp1_);
	val = _tmp1_;
	switch (G_VALUE_TYPE (&val)) {
		case G_TYPE_DOUBLE:
		{
			y = g_value_get_double (&val);
			break;
		}
		case G_TYPE_UINT:
		{
			y = (gdouble) g_value_get_uint (&val);
			break;
		}
		case G_TYPE_UINT64:
		{
			y = (gdouble) g_value_get_uint64 (&val);
			break;
		}
		case G_TYPE_INT:
		{
			y = (gdouble) g_value_get_int (&val);
			break;
		}
		case G_TYPE_INT64:
		{
			y = (gdouble) g_value_get_int64 (&val);
			break;
		}
		default:
		{
			y = 0.0;
			break;
		}
	}
	y -= range_begin;
	y /= range_end - range_begin;
	y = height - (y * height);
	result = y;
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

UsageGraphStackedRenderer*
usage_graph_stacked_renderer_construct (GType object_type)
{
	UsageGraphStackedRenderer * self = NULL;
	self = (UsageGraphStackedRenderer*) g_object_new (object_type, NULL);
	return self;
}

UsageGraphStackedRenderer*
usage_graph_stacked_renderer_new (void)
{
	return usage_graph_stacked_renderer_construct (USAGE_TYPE_GRAPH_STACKED_RENDERER);
}

guint
usage_graph_stacked_renderer_get_column (UsageGraphStackedRenderer* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_column;
	return result;
}

void
usage_graph_stacked_renderer_set_column (UsageGraphStackedRenderer* self,
                                         guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = usage_graph_stacked_renderer_get_column (self);
	if (old_value != value) {
		self->priv->_column = value;
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY]);
	}
}

gdouble
usage_graph_stacked_renderer_get_line_width (UsageGraphStackedRenderer* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_line_width;
	return result;
}

void
usage_graph_stacked_renderer_set_line_width (UsageGraphStackedRenderer* self,
                                             gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = usage_graph_stacked_renderer_get_line_width (self);
	if (old_value != value) {
		self->priv->_line_width = value;
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY]);
	}
}

void
usage_graph_stacked_renderer_get_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                    GdkRGBA * result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_stroke_color_rgba;
	*result = _tmp0_;
	return;
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->red != s2->red) {
		return FALSE;
	}
	if (s1->green != s2->green) {
		return FALSE;
	}
	if (s1->blue != s2->blue) {
		return FALSE;
	}
	if (s1->alpha != s2->alpha) {
		return FALSE;
	}
	return TRUE;
}

void
usage_graph_stacked_renderer_set_stroke_color_rgba (UsageGraphStackedRenderer* self,
                                                    GdkRGBA * value)
{
	GdkRGBA old_value;
	g_return_if_fail (self != NULL);
	usage_graph_stacked_renderer_get_stroke_color_rgba (self, &old_value);
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
		GdkRGBA _tmp0_;
		_tmp0_ = *value;
		self->priv->_stroke_color_rgba = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY]);
	}
}

void
usage_graph_stacked_renderer_get_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                     GdkRGBA * result)
{
	GdkRGBA _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_stacked_color_rgba;
	*result = _tmp0_;
	return;
}

void
usage_graph_stacked_renderer_set_stacked_color_rgba (UsageGraphStackedRenderer* self,
                                                     GdkRGBA * value)
{
	GdkRGBA old_value;
	g_return_if_fail (self != NULL);
	usage_graph_stacked_renderer_get_stacked_color_rgba (self, &old_value);
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
		GdkRGBA _tmp0_;
		_tmp0_ = *value;
		self->priv->_stacked_color_rgba = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY]);
	}
}

static void
usage_graph_stacked_renderer_class_init (UsageGraphStackedRendererClass * klass,
                                         gpointer klass_data)
{
	usage_graph_stacked_renderer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UsageGraphStackedRenderer_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_graph_stacked_renderer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_graph_stacked_renderer_set_property;
	G_OBJECT_CLASS (klass)->finalize = usage_graph_stacked_renderer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY] = g_param_spec_uint ("column", "column", "column", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY] = g_param_spec_double ("line-width", "line-width", "line-width", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY] = g_param_spec_boxed ("stroke-color-rgba", "stroke-color-rgba", "stroke-color-rgba", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY, usage_graph_stacked_renderer_properties[USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY] = g_param_spec_boxed ("stacked-color-rgba", "stacked-color-rgba", "stacked-color-rgba", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
usage_graph_stacked_renderer_dzl_graph_view_renderer_interface_init (DzlGraphRendererInterface * iface,
                                                                     gpointer iface_data)
{
	usage_graph_stacked_renderer_dzl_graph_view_renderer_parent_iface = g_type_interface_peek_parent (iface);
	iface->render = (void (*) (DzlGraphRenderer*, DzlGraphModel*, gint64, gint64, gdouble, gdouble, cairo_t*, cairo_rectangle_int_t*)) usage_graph_stacked_renderer_real_render;
}

static void
usage_graph_stacked_renderer_instance_init (UsageGraphStackedRenderer * self,
                                            gpointer klass)
{
	self->priv = usage_graph_stacked_renderer_get_instance_private (self);
	self->priv->_line_width = 1.0;
}

static void
usage_graph_stacked_renderer_finalize (GObject * obj)
{
	UsageGraphStackedRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
	G_OBJECT_CLASS (usage_graph_stacked_renderer_parent_class)->finalize (obj);
}

static GType
usage_graph_stacked_renderer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UsageGraphStackedRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_graph_stacked_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageGraphStackedRenderer), 0, (GInstanceInitFunc) usage_graph_stacked_renderer_instance_init, NULL };
	static const GInterfaceInfo dzl_graph_view_renderer_info = { (GInterfaceInitFunc) usage_graph_stacked_renderer_dzl_graph_view_renderer_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType usage_graph_stacked_renderer_type_id;
	usage_graph_stacked_renderer_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageGraphStackedRenderer", &g_define_type_info, 0);
	g_type_add_interface_static (usage_graph_stacked_renderer_type_id, dzl_graph_view_renderer_get_type (), &dzl_graph_view_renderer_info);
	UsageGraphStackedRenderer_private_offset = g_type_add_instance_private (usage_graph_stacked_renderer_type_id, sizeof (UsageGraphStackedRendererPrivate));
	return usage_graph_stacked_renderer_type_id;
}

GType
usage_graph_stacked_renderer_get_type (void)
{
	static volatile gsize usage_graph_stacked_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&usage_graph_stacked_renderer_type_id__volatile)) {
		GType usage_graph_stacked_renderer_type_id;
		usage_graph_stacked_renderer_type_id = usage_graph_stacked_renderer_get_type_once ();
		g_once_init_leave (&usage_graph_stacked_renderer_type_id__volatile, usage_graph_stacked_renderer_type_id);
	}
	return usage_graph_stacked_renderer_type_id__volatile;
}

static void
_vala_usage_graph_stacked_renderer_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	UsageGraphStackedRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
	switch (property_id) {
		case USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY:
		g_value_set_uint (value, usage_graph_stacked_renderer_get_column (self));
		break;
		case USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY:
		g_value_set_double (value, usage_graph_stacked_renderer_get_line_width (self));
		break;
		case USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY:
		{
			GdkRGBA boxed;
			usage_graph_stacked_renderer_get_stroke_color_rgba (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY:
		{
			GdkRGBA boxed;
			usage_graph_stacked_renderer_get_stacked_color_rgba (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_usage_graph_stacked_renderer_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	UsageGraphStackedRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_GRAPH_STACKED_RENDERER, UsageGraphStackedRenderer);
	switch (property_id) {
		case USAGE_GRAPH_STACKED_RENDERER_COLUMN_PROPERTY:
		usage_graph_stacked_renderer_set_column (self, g_value_get_uint (value));
		break;
		case USAGE_GRAPH_STACKED_RENDERER_LINE_WIDTH_PROPERTY:
		usage_graph_stacked_renderer_set_line_width (self, g_value_get_double (value));
		break;
		case USAGE_GRAPH_STACKED_RENDERER_STROKE_COLOR_RGBA_PROPERTY:
		usage_graph_stacked_renderer_set_stroke_color_rgba (self, g_value_get_boxed (value));
		break;
		case USAGE_GRAPH_STACKED_RENDERER_STACKED_COLOR_RGBA_PROPERTY:
		usage_graph_stacked_renderer_set_stacked_color_rgba (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

